From 95397ffe926586d6851a8f5df575a909508dab23 Mon Sep 17 00:00:00 2001
From: Marius Gripsgard <marius@ubports.com>
Date: Wed, 23 Sep 2020 00:23:06 +0200
Subject: [PATCH] Add systemd service file

---
 CMakeLists.txt           | 21 ++++++++++++++++++---
 data/hfd-service.service | 12 ++++++++++++
 2 files changed, 30 insertions(+), 3 deletions(-)
 create mode 100644 data/hfd-service.service

diff --git a/CMakeLists.txt b/CMakeLists.txt
index 5a4e45c..04f4f57 100644
--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -34,12 +34,27 @@ add_subdirectory(src)
 add_subdirectory(tools)
 add_subdirectory(qt)
 
-# Dbus file
-install(FILES data/hfd-service.conf 
+FILE(GLOB upstart_file "${CMAKE_CURRENT_SOURCE_DIR}/data/hfd-service.conf")
+FILE(GLOB systemd_file "${CMAKE_CURRENT_SOURCE_DIR}/data/hfd-service.service")
+FILE(GLOB dbus_file "${CMAKE_CURRENT_SOURCE_DIR}/data/com.lomiri.hfd.conf")
+
+# Upstart file
+install(FILES ${upstart_file}
     DESTINATION /etc/init
 )
 
+# Systemd file
+pkg_check_modules(SYSTEMD systemd)
+if (${SYSTEMD_FOUND})
+  pkg_get_variable(SYSTEMD_SYSTEM_DIR systemd systemdsystemunitdir)
+  message (STATUS "${SYSTEMD_SYSTEM_DIR} is the systemd system unit file install dir, installing ${systemd_file} to it")
+  install (FILES "${systemd_file}"
+           DESTINATION "${SYSTEMD_SYSTEM_DIR}")
+else()
+   message(WARNING "Did not find systmed, not installing systemd service")
+endif()
+
 # Dbus policy
-install(FILES data/com.lomiri.hfd.conf
+install(FILES ${dbus_file}
   DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/dbus-1/system.d
 )
diff --git a/data/hfd-service.service b/data/hfd-service.service
new file mode 100644
index 0000000..f0eb393
--- /dev/null
+++ b/data/hfd-service.service
@@ -0,0 +1,12 @@
+[Unit]
+Description=hfd service for feedback support
+Wants=dbus.service
+After=dbus.service
+
+[Service]
+Type=dbus
+BusName=com.lomiri.hfd
+ExecStart=/usr/bin/hfd-service
+
+[Install]
+WantedBy=multi-user.target
